<?php
/*
 * Plugin Audioplayer pour SPIP 3
 * (c) 2008-2013 Jean-Yves Giraud
 */

/*
 * Fonction de traitement du code HTML pour prendre en compte audioplayer
 * Exemple de bloc standard complet DL :
 *
<dl class='spip_document_63 spip_documents spip_documents_center'>
<dt><a href="IMG/mp3/Exemple.mp3" title='MP3 - 547.8&#160;ko'
	type="audio/mpeg"><img src='local/cache-vignettes/L52xH52/mp3-77a42.png' width='52' height='52' alt='MP3 - 547.8&#160;ko' /></a></dt>
<dt class='spip_doc_titre' style='width:120px;'><strong>Exemple de MP3</strong></dt>
<dd class='spip_doc_descriptif' style='width:120px;'>Un petit air de guitare...
</dd>
</dl>
 */
function code_audioplayer($url,$dl,$standard)
{
	unset($matches);
	unset($matches2);
	unset($matches3);
	// Gnration du code object pour le player
	static	$player = NULL;
	$player = find_in_path('player.swf');
	$player_object = "
<object type='application/x-shockwave-flash'
data='$player' height='20' width='200'>
<param name='movie' value='$player'/>
<param name='FlashVars' value='soundFile=$url'>
<param name='menu' value='false'>
<param name='wmode' value='transparent'/>
</object>";
	// Si le modele est standard, on traite et on retourne le bloc DL complet
	if ($standard == true)
	{
		// On remplace la balise a par le code object du player
		preg_match("/<\s*a\s+[^>]*href\s*=\s*[\"']?([^\"' >]+\.mp3)[\"']?[^>]*>(.*)<\/a>/isU", $dl, $matches);
		if($matches[1])
			$dl = str_replace($matches[0],$player_object, $dl);
		// On corrige la largeur de la balise DL (titre)
		preg_match("/<dt\s+[^.]*style\s*=\s*[\"']?([^\"' >]+px;)[\"']?[^>]*>(.*)<\/dt>/isU", $dl, $matches2);
		if($matches2[1])
		{
			$dt = str_replace($matches2[1],'width:200px;', $matches2[0]);
			$dl = str_replace($matches2[0],$dt, $dl);
		}
		// On corrige la largeur de la balise DD (description)
		preg_match("/<dd\s+[^.]*style\s*=\s*[\"']?([^\"' >]+px;)[\"']?[^>]*>(.*)<\/dd>/isU", $dl, $matches3);
		if($matches3[1])
		{
			$dd = str_replace($matches3[1],'width:200px;', $matches3[0]);
			$dl = str_replace($matches3[0],$dd, $dl);
		}
		return $dl;
	}
	// Sinon, on ne retourne que le code object du player
	else
		return $player_object;
}

/*
 * Pipeline affichage_final pour audioplayer
 * Remplacement des liens sur les fichiers MP3 par le code ncessaire au player flash
 */
function audioplayer_affichage_final($flux)
{
	unset($matches);
	preg_match_all("/<dl\s+[^.]*href\s*=\s*[\"']?([^\"' >]+\.mp3)[\"']?[^>]*>(.*)<\/dl>/isU", $flux, $matches);
	// Si on trouve des blocs complets (modele doc standard) pour liens sur des fichiers MP3, on fait le traitement complet DL, DT, DD
	if($matches[1][0])
	{
		$url_a = $matches[1];
		$dl = $matches[0];
		$y = 0;
		// Pour chaque bloc DL contenant un lien sur un fichier de format mp3, remplacer la balise a par le code du
		// player flash + corriger les largeurs pour balises DL et DD (titre + description)
		foreach($url_a as $url){
			$flux = str_replace($dl[$y],code_audioplayer($url,$dl[$y],true), $flux);
			$y++;
		}
	}
	// Sinon, on regarde s'il y a des liens seuls (modele doc non standard), et si oui, on ne remplace que les liens (balise a)
	else
	{
		preg_match_all("/<\s*a\s+[^>]*href\s*=\s*[\"']?([^\"' >]+\.mp3)[\"']?[^>]*>(.*)<\/a>/isU", $flux, $matches);
		if($matches[1][0])
		{
			$url_a = $matches[1];
			$lien = $matches[0];
			$y = 0;
			// Pour chaque lien sur un fichier de format mp3, remplacer par le code du player flash permettant de jouer ce fichier
			foreach($url_a as $url){
				$flux = str_replace($lien[$y],code_audioplayer($url,$dl[$y],false), $flux);
				$y++;
			}
		}
	}
	return $flux;
}

?>